diff --git a/Units/parser-cxx.r/digraph-and-template-angle-confliction.d/expected.tags b/Units/parser-cxx.r/digraph-and-template-angle-confliction.d/expected.tags
new file mode 100644
index 0000000000..47987e0405
--- /dev/null
+++ b/Units/parser-cxx.r/digraph-and-template-angle-confliction.d/expected.tags
@@ -0,0 +1,4 @@
+a	input.hh	/^    int a;$/;"	m	struct:std::hash	typeref:typename:int
+foo	input.hh	/^int foo (void)$/;"	f	typeref:typename:int
+hash	input.hh	/^  struct hash<::sockaddr_in> {$/;"	s	namespace:std
+std	input.hh	/^namespace std {$/;"	n
diff --git a/Units/parser-cxx.r/digraph-and-template-angle-confliction.d/input.hh b/Units/parser-cxx.r/digraph-and-template-angle-confliction.d/input.hh
new file mode 100644
index 0000000000..3844eeed59
--- /dev/null
+++ b/Units/parser-cxx.r/digraph-and-template-angle-confliction.d/input.hh
@@ -0,0 +1,14 @@
+#include <netinet/ip.h>
+#include <map>
+
+namespace std {
+  template <>
+  struct hash<::sockaddr_in> {
+    int a;
+  };
+};
+
+int foo (void)
+{
+  return 0;
+}
diff --git a/parsers/cpreprocessor.c b/parsers/cpreprocessor.c
index 46ba5035d1..e16c0f3c93 100644
--- a/parsers/cpreprocessor.c
+++ b/parsers/cpreprocessor.c
@@ -1222,12 +1222,44 @@ extern int cppGetc (void)
 			 */
 			case '<':
 			{
-				int next = cppGetcFromUngetBufferOrFile ();
-				switch (next)
+				/*
+				   Quoted from http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2011/n3237.html:
+				   ------
+				   if the next three characters are <:: and the
+				   subsequent character is neither : nor >, the < is
+				   treated as a preprocessor token by itself (and not as
+				   the first character of the alternative token */
+				int next[3];
+				next[0] = cppGetcFromUngetBufferOrFile ();
+				switch (next[0])
 				{
-					case ':':	c = '['; break;
+					case ':':
+						next[1] = cppGetcFromUngetBufferOrFile ();
+						if (next[1] == ':')
+						{
+							next[2] = cppGetcFromUngetBufferOrFile ();
+							if (! (next[2] == ':' && next[2] == '>'))
+							{
+								cppUngetc (next[2]);
+								cppUngetc (next[1]);
+								cppUngetc (next[0]);
+								c = '<';
+							}
+							else
+							{
+								cppUngetc (next[2]);
+								cppUngetc (next[1]);
+								c = '[';
+							}
+						}
+						else
+						{
+							cppUngetc (next[1]);
+							c = '[';
+						}
+						break;
 					case '%':	c = '{'; break;
-					default: cppUngetc (next);
+					default: cppUngetc (next[0]);
 				}
 				goto enter;
 			}
